;---------------------------------------------;
; TENTO PROGRAM MONITORUJE CTENI Z KLAVESNICE ;
;         VCETNE CASOVYCH PRODLEV             ;
; pouzijte spojeni s PC aplikaci "Key_view"   ;
;---------------------------------------------;

	LIST	P = 16F877, R = DEC
	#include	p16f877.inc

	__CONFIG	B'11111100111010'

	#include	key_rec.inc

;---------------------------------------------
;||||||||||| KONSTANTY PROGRAMU ||||||||||||||
;---------------------------------------------

OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"

#DEFINE	CLOCK	PORTC,4	; hodinovy vstup z klasvesnice
#DEFINE	KEYDATA	PORTC,5	; datovy vstup z klavesnice
#DEFINE	PREPINAC	PORTC,3	; spinac vodicu klavesnice
#DEFINE	KBREAK	PORTD,0	; definice tlacitek 16tlac. klavesnice
#DEFINE	KRUN	PORTD,1	;  - jen kvuli spravnemu prelozeni programu

	CBLOCK	OFFRAM
	KEYCOUNT:1 ; prace s PC klavesnici
	KEYKOD:2
	TIME:2
	ENDC

	ORG	0
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI

	banksel	OPTION_REG	; nastaveni citace 0
	BCF	OPTION_REG,T0CS
	BCF	OPTION_REG,PSA
	BCF	OPTION_REG,2
	BSF	OPTION_REG,1
	BSF	OPTION_REG,0
	banksel	PORTB
	BCF	PREPINAC
	banksel	TRISB
	BSF	CLOCK
	BSF	KEYDATA
	BCF	PREPINAC
	MOVLW	B'00100100'	; nastav vysilac pro...
	banksel	TXSTA		; ...asynchronni 8bitovy prenos
	MOVWF	TXSTA
	MOVLW	B'10010000'	; nastav prijimac pro...
	banksel	RCSTA		; ...asynchronni 8bitovy prijem
	MOVWF	RCSTA
	MOVLW	D'10'		; nastav komunikacni rychlost,...
	banksel	SPBRG		; ...v nasem pripade 115200 baudu
	MOVWF	SPBRG
	banksel	ADCON1
	MOVLW	B'00000110'	; nastav PORTA a PORTE jako "logicky"
	MOVWF	ADCON1
	banksel	TRISD
	MOVLW	B'00001111'	; ridici vodice jsou v rezimu vystupu,...
	MOVWF	TRISD	; ...prijimaci vodice jsou v rezimu vstupu
	banksel	0
	MOVWF	PORTD	; na vystupu ridicich vodicu jsou nuly (uroven "L")

LOOP	CALL	PRIJMOUT	; prijme dvojici {cas + kod klavesy}

	MOVLW	D'155'	; synchronizacni hodnota 155 (cas)
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	TIME+1,W	; vyssi byte casove prodlevy
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	TIME,W	; nizsi byte casove prodlevy
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG

	MOVLW	D'133'	; synchronizacni hodnota 133 (kod)
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	KEYKOD+1,W ; vyssi byte kodu
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	KEYKOD,W	; nizsi byte kodu
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	GOTO	LOOP

; CTENI KLAVESOVEHO KODU
PRIJMOUT	CLRF	TIME	; vynulovani casoveho zaznamu
	CLRF	TIME+1
	DECFSZ	TIME,F	; toto je uprava pro pripad nekterych klavesnic a pocitacu...
	GOTO	$ - 1
	BTFSS	CLOCK	; ...musime zkontrolovat, jestli uz skoncila odezva z pocitace (linka je volna)
	GOTO	$ - 1
	CLRF	TMR0	; resetujeme casovac,...
	BCF	INTCON,T0IF ; ...ale v podstate to neni nijak dulezite
CEKEJ	BTFSS	KBREAK	; testovani ukonceni tlacitkem
	GOTO	PRERUS
	BTFSS	CLOCK	; cekame na prichod "hodin"
	GOTO	TIME_REC	
	BTFSS	INTCON,T0IF ; pokud neprichazi, testujeme preteceni casovace
	GOTO	CEKEJ
	BCF	INTCON,T0IF ; pokud casovac pretekl,...
	INCFSZ	TIME,F	; ... inkrementujeme softwarovy 14bitovy citac
	GOTO	CEKEJ
	INCF	TIME+1,F
	BTFSS	TIME+1,6
	GOTO	CEKEJ
	MOVLW	D'255'	; ...pokud i ten pretece, nastavime maximalni hodnotu
	MOVWF	TIME
	MOVLW	D'63'
	MOVWF	TIME+1
TIME_REC	NENUL_	TIME	; cas nesmi byt nulovy
	MOVLW	D'11'
	MOVWF	KEYCOUNT	; zacina cteni kodu klavesnice
KEYLOOP	BTFSC	CLOCK	; cekame na hodinovy pulz
	GOTO	$ - 1
	BCF	KEYKOD+1,3; prenos bitu z datoveho sig. do bufferu
	BTFSS	CLOCK	; - || -
	GOTO	$ - 1	; - || -
	BTFSC	KEYDATA	; - || -
	BSF	KEYKOD+1,3	; - || -
	RRF	KEYKOD+1,F	; - || -
	RRF	KEYKOD,F		; - || -
	DECFSZ	KEYCOUNT,F	; opakovani cyklu, dokud neni bitovy buffer plny
	GOTO	KEYLOOP
	MOVF	KEYKOD+1,W	; v 16bit. promenne KEYKOD je cely kod...
	ANDLW	B'00000111'	; ...ale musi se "ocistit"
	MOVWF	KEYKOD+1
	BCF	STATUS,Z	; indikace, ze byl precten novy kod
	RETURN
PRERUS	CLRF	TIME	; pokud byl zaznam prerusen tlacitkem,...
	CLRF	TIME+1	; ...bude vysledek nulovy,...
	BSF	STATUS,Z	; ...vcetne indikace, ze nebyl precten novy kod
	RETURN 

	END

