;-----------------------------------
;   ZAZNAMENAVANI KLAVESOVEHO-KODU
;-----------------------------------

; zaznamenava 16bitovy kod do staticke RAM pameti
; - podprogram pracuje tak, ze opakovane prijima novou hodnotu a
;   nakonec sam prohlasi, ze je zaznam hotov
KEY_REC_	MACRO	KOD_, POZICE_, BLOK1, BLOK2, MAXPOCET
; KOD_ - vstupni 16bitova hodnota (promenna)
; POZICE_ - relativni ukazatel do zaznamu (promenna)
; BLOK1 - (konstanta) adresa zacatku bloku v pameti RAM, do ktere
;         se budou ukladat prvni byty vstupnich hodnot
; BLOK2 - (konstanta) adresa zacatku bloku v pameti RAM, do ktere
;         se budou ukladat druhe byty vstupnich hodnot
; MINPOCET - (konstanta) minimalni pripustna delka kodu
; MAXPOCET - (konstanta) maximalni pripustna delka kodu

	MOVF	POZICE_,W	; nastavime pozici zapisu prvniho bytu
	ADDLW	BLOK1
	bankisel	BLOK1
	MOVWF	FSR
	MOVF	KOD_,W	; zapiseme prvni byte
	MOVWF	INDF
	MOVF	POZICE_,W	; nastavime pozici zapisu druheho bytu
	ADDLW	BLOK2
	bankisel	BLOK2
	MOVWF	FSR
	MOVF	KOD_+1,W	; zapiseme druhy byte
	MOVWF	INDF
	INCF	POZICE_,F	; posunuti (zvyseni)  ukazatele
	MOVF	POZICE_,W
	SUBLW	MAXPOCET  ; testovani maximalni delky kodu
	ENDM

; slouzi ke cteni zaznamu v RAM pameti
KRD_REC_	MACRO	KOD_, POZICE_, BLOK1, BLOK2, MAXPOZICE_
; KOD_ - vytupni 16bitova hodnota (promenna)
; POZICE_ - relativni ukazatel do zaznamu (promenna)
; BLOK1 - (konstanta) adresa zacatku bloku v pameti RAM, ve ktere
;         se nachazi prvni byty hodnot
; BLOK2 - (konstanta) adresa zacatku bloku v pameti RAM, ve ktere
;         se nachazi druhe byty hodnot
	
	MOVF	POZICE_,W	; precteme aktualni hodnotu ze zaznamu:
	ADDLW	BLOK1
	bankisel	BLOK1
	MOVWF	FSR
	MOVF	INDF,W	; - prvni byte
	MOVWF	KOD_
	MOVF	POZICE_,W
	ADDLW	BLOK2
	bankisel	BLOK2
	MOVWF	FSR
	MOVF	INDF,W	; - druhy byte
	MOVWF	KOD_+1
	INCF	POZICE_,F	; zvysime ukazatel
	MOVF	POZICE_,W
	XORWF	MAXPOZICE_,W
	
	ENDM

; Toto makro otestuje, zda 16bitova promenna (KKOD) obsahuje nulu...
; ...a pokud ano, potom ji nastavi na jednicku.
NENUL_	MACRO	KKOD
	LOCAL	KONEC

	MOVF	KKOD+1,F
	BTFSS	STATUS,Z
	GOTO	KONEC
	MOVLW	D'1'
	MOVF	KKOD,F
	BTFSC	STATUS,Z
	MOVWF	KKOD
KONEC
	ENDM
