;--------------------------------------------;
;  UKLADANI A PREHRAVANI ZAZNAMU KLAVESNICE  ;
;!PRIPOJTE KLAVESNICOVYM MODULEM K POCITACI! ;
;  muzete monitorovat programem "Key_view"   ;
;--------------------------------------------;

	LIST	P = 16F877, R = DEC
	#include	p16f877.inc

	__CONFIG	B'11111100111010'

	#include	key_rec.inc
	#include	flash.inc
	#include	displej.inc
	#include	dskripty.inc
	#include	div16u.inc
	#include	tab_util.inc
	#include	vyber.inc

;---------------------------------------------
;||||||||||| KONSTANTY PROGRAMU ||||||||||||||
;---------------------------------------------

#DEFINE	DB4	PORTE,2	; piny pro ovladani displeje
#DEFINE	DB5	PORTE,1
#DEFINE	DB6	PORTE,0
#DEFINE	DB7	PORTA,4
#DEFINE	E	PORTB,1
#DEFINE	RW	PORTB,2
#DEFINE	RS	PORTB,3 

OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"
TEMPRAM	EQU	H'70'	; posledni blok pameti (16 bytu)
			; - je zrcadlen do vsech pametovych bank

#DEFINE	CLOCK	PORTC,4	; hodinovy vstup z klasvesnice
#DEFINE	KEYDATA	PORTC,5	; datovy vstup z klavesnice
#DEFINE	PREPINAC	PORTC,3	; spinac vodicu klavesnice
KEYPORT	EQU	PORTC
KEYMASK	EQU	B'11001111'
#DEFINE	KBREAK	PORTD,0	; definice prerusovaciho/selekcniho tlacitka
#DEFINE	KRUN	PORTD,1	; definice potvrzovaciho tlacitka

REC_ADR_	EQU	D'2048'	; adresa prvniho zaznamu

	CBLOCK	OFFRAM

	TML:1	; pro displej
	TMH:1
	DDATA:1

	AA:2	; pro skripty
	BB:2
	CC:2
	VD16U:1
	NUMFORM_:1

	KEYCOUNT:1	; pro PC klavesnici
	KEYKOD:2
	TIME:2

	KKOD:2	; pro zaznamy
	KPOZICE:1
	MAXPOZICE:1

	REC_ADR:2	; pro selekci ("vyber")
	INDEX:1

	ENDC

BLOK1	EQU	H'110'	; adresa zaznamu v RAM pameti (prvni byty)
BLOK2	EQU	H'190'	; adresa zaznamu v RAM pameti (druhe byty)
MAXKKOD	EQU	D'64'	; maximalni pripustna delka kodu

	ORG	0
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI

	banksel	OPTION_REG
	BCF	OPTION_REG,T0CS
	BCF	OPTION_REG,PSA
	BCF	OPTION_REG,2
	BSF	OPTION_REG,1
	BSF	OPTION_REG,0
	banksel	PORTB
	BCF	PREPINAC
	banksel	TRISB
	BSF	CLOCK
	BSF	KEYDATA
	BCF	PREPINAC
	MOVLW	B'00100100'	; nastav vysilac pro...
	banksel	TXSTA		; ...asynchronni 8bitovy prenos
	MOVWF	TXSTA
	MOVLW	B'10010000'	; nastav prijimac pro...
	banksel	RCSTA		; ...asynchronni 8bitovy prijem
	MOVWF	RCSTA
	MOVLW	D'10'		; nastav komunikacni rychlost,...
	banksel	SPBRG		; ...v nasem pripade 115200 baudu
	MOVWF	SPBRG
	banksel	ADCON1
	MOVLW	B'00000110'	; nastav PORTA a PORTE jako "logicky"
	MOVWF	ADCON1
	banksel	TRISD
	MOVLW	B'00001111'	; ridici vodice jsou v rezimu vystupu,...
	MOVWF	TRISD	; ...prijimaci vodice jsou v rezimu vstupu
	banksel	0
	MOVWF	PORTD	; na vystupu ridicich vodicu jsou nuly (uroven "L")

	CALL	INITDISP	; spusteni displeje

	MOVLW	D'0'	; prvni "obrazovka"
	CALL	SKRIPT
	CLRF	KPOZICE	; resetovani zaznamu
; nasledujici blok je prakticky stejny, jako u predchoziho programu
LOOP	CALL	PRIJMOUT
	BTFSC	STATUS,Z
	GOTO	KONECREC
	MOVLW	D'155'
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	TIME+1,W
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	TIME,W
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	TIME,W
	MOVWF	KKOD
	MOVF	TIME+1,W
	MOVWF	KKOD+1
	CALL	KEY_REC
	BTFSS	STATUS,C
	GOTO	PRYC
	MOVLW	D'133'
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	KEYKOD+1,W	; ...potom pecteme z bufferu a posleme na port dva byty
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	KEYKOD,W
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	KEYKOD,W
	MOVWF	KKOD
	MOVF	KEYKOD+1,W
	MOVWF	KKOD+1
	CALL	KEY_REC
	BTFSC	STATUS,C
	GOTO	LOOP	; navrat k testovani bufferu
	GOTO	PRYC
KONECREC	INCF	KPOZICE,F
; ZAZNAM DO FLASH
PRYC	MOVF	KPOZICE,W	; ulozeni ukazatele a vynulovani ukazatele
	MOVWF	MAXPOZICE
	CLRF	KPOZICE
	; vyber oblasti, kam se ma zaznam ulozit
	VYBER_	REC_ADR_,REC_ADR,D'64',INDEX,D'10',SKRIPT,D'2',DDELAY
	MOVF	REC_ADR+1,W	; nastaveni adresy ve flesh
	banksel	EEADRH
	MOVWF	EEADRH
	banksel	REC_ADR
	MOVF	REC_ADR,W
	banksel	EEADR
	MOVWF	EEADR
	banksel	0

	CALL	KREAD_REC	; precteni a zahozeni prvni polozky
	BTFSC	STATUS,Z
	GOTO	SKOK0
LOOP2	CALL	KREAD_REC	; kopirovani do flash (viz. minuly program)
	BTFSC	STATUS,Z
	GOTO	SKOK0

	MOVF	KKOD,W
	banksel	EEDATA
	MOVWF	EEDATA
	banksel	KKOD+1
	MOVF	KKOD+1,W
	banksel	EEDATH
	MOVWF	EEDATH
	banksel	0
	CALL	FWRITE
	banksel	EEADR
	INCF	EEADR,F
	BTFSC	STATUS,Z
	INCF	EEADRH,F
	banksel	0

	CALL	KREAD_REC
	BTFSC	STATUS,Z
	GOTO	SKOK0

	MOVF	KKOD,W
	banksel	EEDATA
	MOVWF	EEDATA
	banksel	KKOD+1
	MOVF	KKOD+1,W
	banksel	EEDATH
	MOVWF	EEDATH
	banksel	0
	CALL	FWRITE
	banksel	EEADR
	INCF	EEADR,F
	BTFSC	STATUS,Z
	INCF	EEADRH,F
	banksel	0
	MOVF	KKOD,F
	BTFSS	STATUS,Z
	GOTO	LOOP2
	MOVF	KKOD+1,F
	BTFSC	STATUS,Z
SKOK0	
	banksel	EEDATA
	CLRF	EEDATA
	CLRF	EEDATH
	CALL	FWRITE
	banksel	0

; PREHRAVANI POSLOUPNOSTI Z FLASH ZAZNAMU
RUN_IT	MOVLW	D'1'	; vyzva: "odkud to prehrat?"
	CALL	SKRIPT
	BCF	PREPINAC	; PC klavesnice pripojena
	MOVF	PORTD,W	; cekame na uvolneni tlacitek (16tlacitkove miniklavesnice)
	ANDLW	B'00001111'
	XORLW	B'00001111'
	BTFSS	STATUS,Z
	GOTO	$ - 4
	; volba zaznamu uzivatelem
	VYBER_	REC_ADR_,REC_ADR,D'64',INDEX,D'10',SKRIPT,D'1',DDELAY
	BSF	PREPINAC	; PC klavesnice odpojena
	MOVLW	D'3'	; napis: "prehrava se"
	CALL	SKRIPT
	CLRF	TMR0	; prodleva kvuli spolehlivemu sepnuti rele
	BCF	INTCON,T0IF
	BTFSS	INTCON,T0IF
	GOTO	$ - 1

	MOVF	REC_ADR+1,W	; nastaveni zvolene oblasti ve flash
	banksel	EEADRH
	MOVWF	EEADRH
	banksel	REC_ADR
	MOVF	REC_ADR,W
	banksel	EEADR
	MOVWF	EEADR
	banksel	0
	; prehravani zaznamu do klavesoveho portu PC
LOOP3	CALL	FREAD
	banksel	EEADR
	INCF	EEADR,F
	BTFSC	STATUS,Z
	INCF	EEADRH,F

	banksel	EEDATA
	MOVF	EEDATA,W
	banksel	KKOD
	MOVWF	KKOD
	banksel	EEDATH
	MOVF	EEDATH,W
	banksel	KKOD+1
	MOVWF	KKOD+1

	MOVF	KKOD,F	; test nuly
	BTFSS	STATUS,Z
	GOTO	SKOK1
	MOVF	KKOD+1,F
	BTFSS	STATUS,Z
	GOTO	SKOK1
	GOTO	RUN_IT	; pokud je nula, potom cteni konci

SKOK1	MOVLW	D'133'	; ...potom posleme na TX-port hodnotu 133
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	KKOD+1,W	; ...potom pecteme z bufferu a posleme na port dva byty
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	KKOD,W
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG

	CALL	VYSLIKEY	; generovani klavesnicoveho kodu

	CALL	FREAD
	banksel	EEADR
	INCF	EEADR,F
	BTFSC	STATUS,Z
	INCF	EEADRH,F
	banksel	EEDATA
	MOVF	EEDATA,W
	banksel	KKOD
	MOVWF	KKOD
	banksel	EEDATH
	MOVF	EEDATH,W
	banksel	KKOD+1
	MOVWF	KKOD+1

	MOVF	KKOD,F
	BTFSS	STATUS,Z
	GOTO	SKOK2
	MOVF	KKOD+1,F
	BTFSS	STATUS,Z
	GOTO	SKOK2
	GOTO	RUN_IT

SKOK2	MOVLW	D'155'	; ...potom posleme na TX-port hodnotu 133
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	KKOD+1,W	; ...potom pecteme z bufferu a posleme na port dva byty
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	KKOD,W
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	CALL	CEKEJ2	; realizace casove prodlevy
	GOTO	LOOP3

;------------------------------------------------
; CTENI KLAVESOVEHO KODU
PRIJMOUT	CLRF	TIME	; vynulovani casoveho zaznamu
	CLRF	TIME+1
	DECFSZ	TIME,F	; toto je uprava pro pripad nekterych klavesnic a pocitacu...
	GOTO	$ - 1
	BTFSS	CLOCK	; ...musime zkontrolovat, jestli uz skoncila odezva z pocitace (linka je volna)
	GOTO	$ - 1
	CLRF	TMR0	; resetujeme casovac,...
	BCF	INTCON,T0IF ; ...ale v podstate to neni nijak dulezite
CEKEJ	BTFSS	KBREAK	; testovani ukonceni tlacitkem
	GOTO	PRERUS
	BTFSS	CLOCK	; cekame na prichod "hodin"
	GOTO	TIME_REC	
	BTFSS	INTCON,T0IF ; pokud neprichazi, testujeme preteceni casovace
	GOTO	CEKEJ
	BCF	INTCON,T0IF ; pokud casovac pretekl,...
	INCFSZ	TIME,F	; ... inkrementujeme softwarovy 14bitovy citac
	GOTO	CEKEJ
	INCF	TIME+1,F
	BTFSS	TIME+1,6
	GOTO	CEKEJ
	MOVLW	D'255'	; ...pokud i ten pretece, nastavime maximalni hodnotu
	MOVWF	TIME
	MOVLW	D'63'
	MOVWF	TIME+1
TIME_REC	NENUL_	TIME	; cas nesmi byt nulovy
	MOVLW	D'11'
	MOVWF	KEYCOUNT	; zacina cteni kodu klavesnice
KEYLOOP	BTFSC	CLOCK	; cekame na hodinovy pulz
	GOTO	$ - 1
	BCF	KEYKOD+1,3; prenos bitu z datoveho sig. do bufferu
	BTFSS	CLOCK	; - || -
	GOTO	$ - 1	; - || -
	BTFSC	KEYDATA	; - || -
	BSF	KEYKOD+1,3	; - || -
	RRF	KEYKOD+1,F	; - || -
	RRF	KEYKOD,F		; - || -
	DECFSZ	KEYCOUNT,F	; opakovani cyklu, dokud neni bitovy buffer plny
	GOTO	KEYLOOP
	MOVF	KEYKOD+1,W	; v 16bit. promenne KEYKOD je cely kod...
	ANDLW	B'00000111'	; ...ale musi se "ocistit"
	MOVWF	KEYKOD+1
	BCF	STATUS,Z	; indikace, ze byl precten novy kod
	RETURN
PRERUS	CLRF	TIME	; pokud byl zaznam prerusen tlacitkem,...
	CLRF	TIME+1	; ...bude vysledek nulovy,...
	BSF	STATUS,Z	; ...vcetne indikace, ze nebyl precten novy kod
	RETURN 


; generovani casove prodlevy (nevyzaduje komentar)
CEKEJ2	MOVF	KKOD,W
	XORLW	D'255'
	MOVWF	TIME
	MOVF	KKOD+1,W
	XORLW	D'255'
	MOVWF	TIME+1
	CLRF	TMR0
	BCF	INTCON,T0IF
CEKEJ2_	BTFSS	INTCON,T0IF
	GOTO	CEKEJ2_
	BCF	INTCON,T0IF
	INCFSZ	TIME,F
	GOTO	CEKEJ2_
	INCFSZ	TIME+1,F
	GOTO	CEKEJ2_
	RETURN

; generovani klavesnicoveho kodu
VYSLIKEY	MOVF	KKOD,W	; kopirovani KKOD do KEYKOD
	MOVWF	KEYKOD
	MOVF	KKOD+1,W
	MOVWF	KEYKOD+1 
	MOVLW	D'11'	; pocet bitu
	MOVWF	KEYCOUNT
	MOVLW	KEYMASK	; nastavime port pro simulaci...
	ANDWF	KEYPORT,F	; ...otevreneho kolektoru
VYSLILOOP	MOVLW	D'239'	; casovani jednoho obdelniku hodin
	MOVWF	TMR0
	BCF	INTCON,T0IF
	BTFSS	KEYKOD,0
	GOTO	K_ZEMI
	banksel	TRISC	; nastaveni hrany hodin a dat (v rezimu otevreneho kolektoru)
	BSF	KEYDATA
	BCF	CLOCK
	banksel	PORTC
	GOTO	VYSLSKOK_
K_ZEMI	
	banksel	TRISC
	BCF	KEYDATA
	BCF	CLOCK
	banksel	PORTC
VYSLSKOK_	BTFSS	INTCON,T0IF	; cekame na konec casovani obdelniku
	GOTO	$ - 1
	banksel	TRISC	; generujeme opacnou hranu hodin
	BSF	CLOCK
	banksel	PORTC
	MOVLW	D'239'	; nastavine casovani druheho obdelniku
	MOVWF	TMR0
	BCF	INTCON,T0IF
	RRF	KEYKOD+1,F	; posouvame obsah KEYKOD, abychom...
	RRF	KEYKOD,F		; ...meli pripraveny dalsi bit na kraji
	BTFSS	INTCON,T0IF	; cekame na konec casovani obdelniku
	GOTO	$ - 1
	DECFSZ	KEYCOUNT,F	; opakovani cyklu
	GOTO	VYSLILOOP
	banksel	TRISC
	BSF	KEYDATA	; deaktivujeme datovy signal
	banksel	PORTC
	RETURN

; zaznam klavesove posloupnosti
KEY_REC	KEY_REC_	KKOD, KPOZICE, BLOK1, BLOK2, MAXKKOD
	RETURN

; cteni klavesove posloupnosti
KREAD_REC	KRD_REC_	KKOD, KPOZICE, BLOK1, BLOK2, MAXPOZICE
	RETURN

; zapis do flash
FWRITE	FWRITE_	0,1
	RETURN

; cteni z flash
FREAD	FREAD_
	RETURN

; 16bitove deleni
DIV16U	DIV16U_M	AA,BB,CC,VD16U 

; zobrazovaci skripty
SKRIPT	SKRIPT_	TABULKY, PUTZNAK, DPRIKAZ, NUMFORM_, DIV16U, AA, BB, CC
	RETURN

	; obsluha displeje
	DISPLEJ	TMH,TML,DDATA,DB4,DB5,DB6,DB7,E,RW,RS


;---------------------
; |||||| DATA ||||||||
;---------------------

TABULKY	DATA	NAPIS1
	DATA	NAPIS2
	DATA	NAPIS3
	DATA	NAPIS4

NAPIS1	POS_D	D'0'
	DE	"generujte klave-"
	POS_D	D'64'
	DE	" sovou posloup. "
	EOFS 

NAPIS2	POS_D	D'0'
	DE	" muzete prehrat "
	POS_D	D'64'
	DE	"posloupnost! "
	PRINTV	INDEX,B'00111',0,0,0,1
	DBLOK	' ',D'3'
	EOFS 

NAPIS3	POS_D	D'0'
	DE	"ulozit na index:"
	POS_D	d'64'
	DE	"            "
	PRINTV	INDEX,B'00111',0,0,0,1
	DBLOK	' ',D'3'
	EOFS

NAPIS4	POS_D	D'0'
	DE	"!!PREHRAVA SE!! "
	POS_D	D'64'
	DE	"                "
	EOFS

	END
